- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# RSAFunction_ISO Class Reference

Inheritance diagram for RSAFunction_ISO:

List of all members.

## Detailed Description

Definition at line 106 of file rsa.h.

## Public Member Functions
Integer | ApplyFunction (const Integer &x) const
Integer | PreimageBound () const
void | Initialize (const Integer &n, const Integer &e)
OID | GetAlgorithmID () const
void | BERDecodePublicKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
| decode subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header
void | DEREncodePublicKey (BufferedTransformation &bt) const
| encode subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| check this object for errors
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| to be implemented by derived classes, users should use one of the above functions instead
void | AssignFrom (const NameValuePairs &source)
| assign values from source to this object
Integer | ImageBound () const
const Integer & | GetModulus () const
const Integer & | GetPublicExponent () const
void | SetModulus (const Integer &n)
void | SetPublicExponent (const Integer &e)
Integer | ApplyRandomizedFunction (RandomNumberGenerator &rng, const Integer &x) const
bool | IsRandomized () const
virtual Integer | MaxPreimage () const
virtual Integer | MaxImage () const
void | BERDecode (BufferedTransformation &bt)
| decode this object from a BufferedTransformation, using BER (Basic Encoding Rules)
void | DEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using DER (Distinguished Encoding Rules)
virtual bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
virtual bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
void | Save (BufferedTransformation &bt) const
| save key into a BufferedTransformation
void | Load (BufferedTransformation &bt)
| load key from a BufferedTransformation
virtual void | BEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using BER
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| throws InvalidMaterial if this object fails Validate() test
virtual bool | SupportsPrecomputation () const
| Returns: whether this object supports precomputation
virtual void | Precompute (unsigned int n)
| do precomputation
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| retrieve previously saved precomputation
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| save precomputation for later use
void | DoQuickSanityCheck () const
template<class T>
bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T>
bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T>
bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
## Static Public Member Functions
static void __cdecl | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch
## Protected Attributes
Integer | m_n
Integer | m_e

## Member Function Documentation

bool RSAFunction::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level |
| ) |  |  | const`[virtual, inherited]`

check this object for errors

Parameters:

  | level | denotes the level of thoroughness: 0 - using this object won't cause a crash or exception (rng is ignored) 1 - this object will probably function (encrypt, sign, etc.) correctly (but may not check for weak keys and such) 2 - make sure this object will function correctly, and do reasonable security checks 3 - do checks that may take a long time

Returns:
  true if the tests pass

Implements CryptoMaterial.

Reimplemented in InvertibleRSAFunction.

Definition at line 70 of file rsa.cpp.

References Integer::IsOdd(), RSAFunction::m_e, RSAFunction::m_n, and Integer::One().

Referenced by InvertibleRSAFunction::Validate().

void RSAFunction::AssignFrom | ( | const NameValuePairs & | source | ) | `[virtual, inherited]`

assign values from source to this object

Note:
  This function can be used to create a public key from a private key.

Implements CryptoMaterial.

Reimplemented in InvertibleRSAFunction.

Definition at line 86 of file rsa.cpp.

void ASN1CryptoMaterial< PublicKey >::Load | ( | BufferedTransformation & | bt | ) | `[inline, virtual, inherited]`

Reimplemented from CryptoMaterial.

Reimplemented in InvertibleRSAFunction.

Definition at line 240 of file asn.h.

References ASN1Object::BERDecode().

virtual void ASN1Object::BEREncode | ( | BufferedTransformation & | bt | ) | const`[inline, virtual, inherited]`

encode this object into a BufferedTransformation, using BER

this may be useful if DEREncode() would be too inefficient

Definition at line 1597 of file cryptlib.h.

Referenced by ASN1CryptoMaterial< PublicKey >::Save().

virtual void CryptoMaterial::Precompute | ( | unsigned int | n | ) | `[inline, virtual, inherited]`

do precomputation

The exact semantics of Precompute() is varies, but typically it means calculate a table of n objects that can be used later to speed up computation.

Reimplemented in DL_GroupParameters< T >, DL_PrivateKeyImpl< GP >, DL_PublicKeyImpl< GP >, DL_GroupParameters< Integer >, DL_GroupParameters< typenameEcPrecomputation< EC >::Element >, DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >, and DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >.

Definition at line 1034 of file cryptlib.h.

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value |
| ) |  |  | const`[inline, inherited]`

get a named value with type int

used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case)

Definition at line 280 of file cryptlib.h.

Referenced by InvertibleRWFunction::GenerateRandom(), InvertibleRSAFunction::GenerateRandom(), InvertibleRabinFunction::GenerateRandom(), InvertibleLUCFunction::GenerateRandom(), DL_GroupParameters_IntegerBased::GenerateRandom(), DL_GroupParameters_DSA::GenerateRandom(), InvertibleESIGNFunction::GenerateRandom(), and Integer::GenerateRandomNoThrow().

The documentation for this class was generated from the following files:

- rsa.h
- rsa.cpp